	title 'PROF-80 Multi density diskette handler'

;    CP/M-80 Version 3     --  Modular BIOS

;	Disk I/O Module for PROF-80

	;		Letzte Aenderung am 24.11.1984 (Joachim)
	;		19.09.1988 Vortex-Schneider Format 5.25"
	;		           SHARP-MZ 8xx     Format 5.25"
	;			   IBM PC-MSDOS     Format 5.25"
	;		07.12.1988 TA-MEZ 80 Tr.    Format 5.25"
	;			   in DPB und Disk$Type$List
	;			   eingebaut
	;		25.12.1988 Format R.Klaus DP5D3 mit 10 secs und offs2
	;			   eingebaut
	;               17.08.2006 Armin, 3,5" 1,44MB
	;		           Flag fuer ldrbios
	;			   Flag fuer Debug-Messages

true	equ -1
false	equ not true

ldrbios	equ true		; AD: true falls fuer loader bios
debug	equ false		; AD: anzeige debug meldungen
track80	equ true		; AD: true=support fuer 40 track in 80 lw


if not ldrbios
	dseg
endif

    ; Disk drive dispatching tables for linked BIOS

	public	fdsd0
if not ldrbios
	public  fdsd1,fdsd2,fdsd3
endif

if debug
	public	?phexw,?phex
endif


    ; Variables containing parameters passed by BDOS

	extrn	@adrv,@rdrv
	extrn	@dma,@trk,@sect
	extrn	@dbnk,@cbnk

    ; System Control Block variables
if not ldrbios
	extrn	@ermde		; BDOS error mode
endif

    ; Utility routines in standard BIOS

	extrn	?wboot	; warm boot vector
	extrn	?pmsg	; print message @<HL> up to 00, saves <BC> & <DE>
	extrn	?pdec	; print binary number in <A> from 0 to 99.
	extrn	?pderr	; print BIOS disk error header
	extrn	?conin,?cono	; con in and out
	extrn	?const		; get console status
if not ldrbios
	extrn	?bank
else
	public	fd$write,fd$read,fd$login,fd$init0
endif

    ; Utility routines in PROF-80 BIOS

	extrn	monon,monoff



	maclib cdef
;
	maclib cpm3
;
	maclib z80
;
	maclib monvec
;
	maclib syspage

    ; common control characters

cr	equ 13
lf	equ 10
bell	equ 7

if not ldrbios
    ; Extended Disk Parameter Headers (XPDHs)

	dw	fd$write
	dw	fd$read
	dw	fd$login
	dw	fd$init
	db	0,0		; relative drive zero
fdsd0	dph     skew8,dp8d3a,64,144

	dw	fd$write
	dw	fd$read
	dw	fd$login
	dw	fd$init0
	db	1,0		; relative drive one

fdsd1	dph	skew8,dp8d3a,64,144

	dw	fd$write
	dw	fd$read
	dw	fd$login
	dw	fd$init0
	db	2,0		; relative drive two
fdsd2	dph	skew8,dp8d3a,64,144

	dw	fd$write
	dw	fd$read
	dw	fd$login
	dw	fd$init0
	db	3,0		; relative drive three
fdsd3	dph	skew8,dp8d3a,64,144

	cseg	; DPB must be resident
else

	dw	fd$write
	dw	fd$read
	dw	fd$login
	dw	fd$init0
	db	0,0			; relative drive zero
fdsd0 	dw	skew8			; translate table address
	db	0,0,0,0,0,0,0,0,0	; BDOS scratch area
       	db	0			; media flag
      	dw	dp8d3a			; disk parameter block
      	dw	csv			; checksum vector
      	dw	alv			; allocation vector
      	dw	dirbcb			; DIRBCB
      	dw	dtabcb			; DTABCB
      	dw	0FFFFh			; HASH
       	db	0			; HASH bank


dirbcb 	db	0FFh			; disk drive
       	db	0,0,0			; record position
       	db	0			; write buffer flag
       	db	0			; BDOS scratch byte
       	dw	0FFFH			; track
       	dw	0			; sector
      	dw	DIRBUF			; directory buffer
	db	0			; BANK
	dw	0			; LINK


dtabcb:	DB	0FFH			; DRV
	DB	0,0,0			; REC #
	DB	0			; WFLG
	DB	0			; SCRATCH
	DW	0FFFH			; TRACK
	DW	0			; SECTOR
	DW	DTABUF			; Data buffer
	DB	0			; BANK
	DW	0			; LINK

endif

; dpb	physical$sector$size,	- disk parameter block
;	physical$sectors$per$track,
;	number$tracks,
;	block$size,
;	number$dir$entries,
;	track$offset,
;	checksum$vec$size		(optional)


dp8s0	dpb 128,26,77,1024,64,2
dp8d3	dpb 1024,8,77,2048,128,2
dp8d1a	dpb 256,52,77,4096,128,2
dp8d2a	dpb 256,26,77,2048,128,2	; TRS 80 MII
;dp8d2a	dpb 512,30,77,2048,256,2
dp8d3a	dpb 1024,16,77,8192,256,2
dp8d4	dpb 512,36,80,4096,256,1        ; AD: 1.44MB floppies
dp5d1	dpb 256,16,40,1024,64,4
dp5d2	dpb 1024,5,40,1024,64,3
;dp5d3	dpb 1024,5,80,2048,128,3	; PROF #2
;dp5d3	dpb 1024,10,80,2048,128,2	; Format R.Klaus war 5sec und 3 offs.
dp5d2a	dpb 512,20,40,2048,128,3            
dp5d3a	dpb 512,20,80,2048,128,3	; PROF #4
dp5d4	dpb 512,18,80,4096,128,1        ; VORTEX DS DD FORMAT, SCHNEIDER CPC
dp5d4a	dpb 512,18,40,2048,64,0         ; MS-PCDOS FORMAT
dp5d5	dpb 512,8,40,2048,64,1          ; MZ-8xx  ---> geht nur einseitig (Spurueberl.)
;dp5d5	dpb 512,8,40,1024,64,1		; IBM CP/M 86 SS DD
;dp5d5a	dpb 256,32,81,2048,128,1        ; MEZ-80 TA-PC80   !!!! 81 Tracks !!!!
;dp5d6	dpb 256,32,40,4096,128,2	; TA-40 Track
DPMAIS10
	dpb 256,32,80,2048,128,6	; MAI S/10


if not ldrbios
	dseg
endif

skew26	skew	26,6,1
	skew1	26,6,1

skew15	skew	26,4,1

;skew15	skew	15,4,1
;	skew1	15,4,1

skew8	skew	8,3,1
	skew1	8,3,1

skew5	skew	5,1,1
	skew1	5,1,1

skew10	skew	10,2,1
	skew1	10,2,1

noskew	skew	16,1,1

noskew18	skew	18,3,1		; ad: for 1,44 MB
		skew1	18,3,1

skew9   skew	9,1,1                   ; VORTEX DS DD SKEWFAKTOR 1; PC-MSDOS SKEW
	skew1	9,1,1

skew2   skew	8,1,1
	skew1	8,1,1                   ; MZ-8xx SKEW

;skew3	skew	16,1,1			; MEZ-80 TA-PC80
;	skew1	16,1,1

;skew52	skew	5,2,1			; Format R.Klaus
;	skew1	5,2,1

SKEWMAIS10:	skew 16,1,1
		skew1 16,1,1		; MAI S/10


    ; Disk I/O routines for standardized BIOS interface

; Initialization entry point.

;		called for first time initialization.


fd$init:
	lxi	h,disk$type$list	; setze Zeiger auf
	shld	typelist		; disk$type$list
fd$init0:
	ret


if debug
tdiraddr:	db 'dirbuf @',0
tdtaaddr:	db 'dtabuf @',0
tcrlf:		db 13,10,0
endif


fd$login:
		; This entry is called when a logical drive is about to
		; be logged into for the purpose of density determination.

		; It may adjust the parameters contained in the disk
		; parameter header pointed at by <DE>

	push	d
if debug
	push	d
	push	h
	lxi	h,tdiraddr
	call	?pmsg
	lxi	h,DIRBUF
	call	?phexw
	lxi	h,tcrlf
	call	?pmsg

	lxi	h,tdtaaddr
	call	?pmsg
	lxi	h,DTABUF
	call	?phexw
	lxi	h,tcrlf
	call	?pmsg
	pop	h
	pop	d

endif
	pop	d


	push	d		; save pointer to dph
	call	test$format	; test disk format
	pop	d		; get back dph pointer
	cpi	0ffh		; disk not correct
	jrz	disk$not$korr	; dann sprung
	lxi	h,-1		; zeiger auf drive typ ???
	dad	d		; ADD HL,DE, HL=@DPH-1
	mov	m,a		; setze drive type in xdph
	mov	l,a		; setze dph, a=format
	mvi	h,0		; hl=format-nummer
	dad	h		; ADD HL,HL
	dad	h		;
	dad	h		; -> Drive Type * 8
	lxi	b,disk$type$list+4
	dad	b		; add hl,bc, hl zeigt auf neue dpb adr
	push	h		;
	exx			; zweitregistersatz
	pop	h		; hl=ptr neuer dpb
	mov	c,m		; hole
	inx	h		; adresse des dpb
	mov	b,m		; 
	inx	h		; in BC
	mov	e,m		; und die
	inx	h		; skew tabelle
	mov	d,m		; in DE
	exx			;
	push	d		; dph adr. in zweitregister
	exx			;
	pop	h		;
	mov	m,e		;
	inx	h		;
	mov	m,d		;
	lxi	d,11		;
	dad	d		;
	mov	m,c		;
	inx	h		;
	mov	m,b		;
	exx			;
	ret			;
disk$not$korr:
	; setze stack so, dass hl=0 wenn seldsk zum bdos zurueckkehrt
	pop	d	; returnadresse
	pop	h	; dph adresse
	lxi	h,0	; setze dph adresse auf 0 (platte nicht erkennbar)
	push	h	; stack wieder herstellen
	push	d	;

if debug
	push a
	mov a,l
	push a
	push h
	lxi h,disk$det$err
	call ?pmsg			; error header
	pop h
	pop a
	mov l,a
	pop a
endif
	ret

if debug

PRVAL:
	;WANDELT INTEGER IN A (RANGE 0-F)
        ;IN ASCII ZEICHEN (REG. C)
	ANI	0FH     ;LOESCHE OBERE 4 BITS
	CPI	0AH	;A-F?
        JNC     PRVAL1  ;JA
        ADI     30H     ;0-9 => ADDIERE 30H DAZU
        MOV     C,A  
        RET
PRVAL1  ADI     37H     ;A-F => ADDIERE 37H DAZU
	MOV	C,A
        RET

	
?phex:
	;GIBT AKKU INHALT ALS HEXZAHL AUS
	PUSH	H
	PUSH	B	;RETTE BC REG
        PUSH    PSW
        RRC
        RRC
        RRC
        RRC
        ANI	0FH	;OBERE ZIFFER 0
        CALL    PRVAL   ;WANDLE NACH ASCII
        CALL    ?cono   ;GEBE ZEICHEN AUS
        POP     PSW     ;HOLE ORG. BYTE
        ANI     0FH
        CALL    PRVAL
        CALL    ?cono
        POP     B	;RESTORE BC
	POP	H
        RET

?phexw:	; HL als hex ausgeben
	PUSH	A
	MOV	A,H
	CALL	?phex
	MOV	A,L
	CALL	?phex
	POP	A
	RET

?comma: PUSH	B
	MVI	C,','
	CALL	?cono
	POP	B
	RET

disk$det$err:
	db 'Unable to detect disk format, can not boot from this disk',13,10,0

dtxt$trk:	db 'R: Trk ',0
dtxt$sek:	db ' Sek: ',0
dtxt$hd:	db ' Head: ',0
dtxt$dma:	db ' @ ',0
dtxt$ok:	db ' Ok',13,10,0
dtxt$err:	db ' Err',13,10,0

show$read$params:
	push	a
	push	b
	push	d
	push	h		; push hl
	lxi	h,dtxt$trk
	call	?pmsg		; show header
	lda	@trk		; show
	mov	l,a
	mvi	h,0
	call	?pdec		; track

	lxi	h,dtxt$sek
	call	?pmsg
	lhld	@sect		; sektor
	mov	a,l		;
	ani	01111111b	; blende head bit aus
	mov	l,a
	call	?pdec

	lxi	h,dtxt$hd	; head-txt
	call	?pmsg

	lhld	@sect		; sektor
	mov	a,l
	ani	80h		; war es die zweite seite
	jz	showh0
	mvi	a,1		; head 1
	jmp	show$2
showh0	mvi	a,0
show$2	mov	l,a
	mvi	h,0
	call	?pdec

	lxi	h,dtxt$dma
	call	?pmsg
	lhld	@dma
	call	?phexw

	pop	h
	pop	d
	pop	b
	pop	a
	ret

show$res:
	push	psw
	push	a
	push	h
	ora	a		; fehler?
	jrz	show$ok		; sprung wenn nein

	lxi	h,dtxt$err
	call	?pmsg
	pop	h
	pop	a
	ret

show$ok:	
	lxi	h,dtxt$ok
	call	?pmsg
	pop	h
	pop	a
	pop	psw
	ret


endif

; disk READ and WRITE entry points.

		; these entries are called with the following arguments:

			; relative drive number in @rdrv (8 bits)
			; absolute drive number in @adrv (8 bits)
			; disk transfer address in @dma (16 bits)
			; disk transfer bank	in @dbnk (8 bits)
			; disk track address	in @trk (16 bits)
			; disk sector address	in @sect (16 bits)
			; pointer to XDPH in <DE>

		; they transfer the appropriate data, perform retries
		; if necessary, then return an error code in <A>
fd$write:
	mvi	a,0ffh
if not ldrbios
	jr	rwcom
else
	ret	; no write support in loader bios
endif


fd$read:
if debug
	call	show$read$params
endif
	xra	a
rwcom:
	sta	roderw		; read oder write
	xchg			; save dph adress
	shld	current$dph
more$retries:
	mvi	a,0ffh		; unterdruecke fehlermeldung
	sta	dermsg
	mvi	a,5		; fuenf versuche
	sta	rwretry
	
	call	rwcom1		; lesen und schreiben von common

	ora	a		; fehler?
	jrz	rwcom3		; sprung wenn nein
	lda	rest+1		; write protect?
	ani	2		;
	jrnz	rwcom3		; ja, fehlercode 2 (zufall)
	call	test$format	; format geaendert?
	lhld	current$dph
	dcx	h
	cmp	m		; format gleich ?
	mvi	a,0ffh
	jrnz	rwcom3		; sprung wenn formatwechsel
if ldrbios
	mvi	a,0		; Fehlermeldungen vom Eprom erlauben
else
	lda	@ermde		; fehlermeldung zugelassen?
endif
	sta	dermsg

	call	rwcom1		; zweiter lese-schreib-versuch

	ora	a		; fehler ?
	jrz	rwcom3		; sprung falls nein
if not ldrbios
	lda	@ermde
	ora	a
	jrnz	rwcom6
endif
	lxi	h,retrymsg
	call	?pmsg
	call	conin$echo
	cpi	'Y'
	jrz	more$retries
rwcom6	
	mvi	a,1
rwcom3
if debug
	call	show$res
endif
	ret


conin$echo:
	call	?conin
	push	psw
	mov	c,a
	call	?cono
	pop	psw
	cpi	'a'
	rc
	sui	'a'-'A'
	ret

retrymsg:
	db	10,13,' Retry (Y/N) ?',0



setup:
	; setze alle parameter in CMDTAB
	; setze 9229 auf mini/maxi betrieb
	; setze floppy-speed auf 300/360 upm

	lhld	current$dph	; zeiger auf plattentyp setzen
	xchg			;
	lxi	h,-1		;
	dad	d		;
	mov	l,m		; zeiger auf disk$type$list eintrag
	mvi	h,0		;
	dad	h		;
	dad	h		;
	dad	h		;
	lxi	b,disk$type$list;
	dad	b		;
	mov	a,m		;
	ani	20h		; setze auf mini/maxi
	jrz	setup1		;
	call	miniset		;
	jr	setup2		;
setup1	call	maxiset		;
setup2	mov	a,m		; setze auf fast/slow
	ani	10h		; if bit set then drive = slow
	jrz	setup$fast
	call	slowset
	jr	setup2a
setup$fast:
	call	fastset
setup2a	mov	a,m		; setze diskformat in cmdtab
	mov	c,a		;
	ani	40h		; setze mfm bit
	sta	cmdtab		;
	mov	a,c		; setze sektorgrroesse
	ani	00000011b	;
	sta	secsz		;
	ora	a		; setze dtl
	mvi	a,0ffh		;
	jrnz	setup3		;
	mvi	a,80h		;
setup3	sta	dtll		;
	inx	h		; setze eot
	mov	a,m		;
	sta	eot		;
	inx	h		; setze gap laenge
	mov	a,m		;
	sta	gapll		;
	inx	h		; setze write precompensation
	mov	a,m		;
	sta	write$precom	;
	lda	@rdrv		; laufwerk
	ani	00000011b	;
	sta	unit
;--------------------------------
	;* hier wird fuer das zweiseitige IBM Format
	;* die Track}ebersetzung durchgefuehrt
	;* Die Parameter muessen in der DISK$TYPE$LIST
	;* an erster Stelle = Typ 0 vereinbart sein
	;* Organisation v0,v1,..v39,r39,r38,..r0

	lxi	h,-1		;* xdph-1 adressieren,um drive typ
	dad	d		;* zu testen
	mov	a,m		;* drive typ
	cpi	0		;* typ 0 ist ibm double side
	jrnz	setup4		;* nein
	sta	head		;* head 0 einstellen
	lda	@trk		;* track
	sta	track		;* einstellen
	mov	l,a		;* und nach L
	mvi	a,39		;*
	sub	l		;* 39 - track
	mov	l,a		;* ergebnis nach L
	jrnc	setup5		;* <=39, dann ist die Sache schon erledigt
	mvi	a,1		;* fuer track >39 head 1 einstellen
	sta	head		;* und die tracknummer fuer die rueckseite
	mvi	a,40		;* berechnen, tr 40,41..79 wird 39,38..0
	add	l		;* 40+(39-track)
	sta	track		;* und ablegen
setup5	lda	@sect		;* nun noch den
	sta	sector		;* sector
	ret			;* fertig
setup4				;*
;--------------------------------

	lda	@trk		; spur
	sta	track		;
	lhld	@sect		; sektor
	mov	a,l		;
	ani	01111111b	; blende head bit aus
	sta	sector		;
	xra	a		; head
	sta	head		;
	mov	a,l		;
	ani	80h		; war es die zweite seite
	rz			; dann zurueck
	mvi	a,1		;
	sta	head		;
	ret			;


miniset:
	push	psw
	mvi	a,pad$mini or 1
	out	p$ls259
	pop	psw
	ret

maxiset:
	push	psw
	mvi	a,pad$mini
	out	p$ls259
	pop	psw
	ret

; fastset und slowset nicht im org bios
fastset:
	mvi	a,pad$inuse or 80H
	out	p$ls259
	ret

slowset:
	mvi	a,pad$inuse
	out	p$ls259
	ret


if not ldrbios
	cseg
endif

rwcom1:
	call	setup		; lese-schreib-kern
	call	setmem		; muss in common liegen
	call	monon
	lda	roderw
	ora	a
	jrz	rwcom2
	call	mwrite
	jr	rwcom5
rwcom2	call	mread
rwcom5	call	monoff
	push	psw
	call	bank0
	pop	psw
	ret


; FEHLER, CHECK
setmem:
	; setze kacheln fuer uebertrag
	; und dmaadresse
	mvi	a,1		; ein sektor uebertragen
	sta	sectcnt		;
	lhld	@dma		; lese dma adresse
if not ldrbios			; AD: im ldrbios wird nix unter 3000 geladen
	mvi	a,2ah		; unter 3000h ?
	cmp	h		;
	jrnc	setmem1		; wenn ja, sprung
endif
	shld	dmaadr		; trage dmaadresse ein
if not ldrbios
	lda	@dbnk		; setze dmabank
	call	?bank		;
endif
	ret			;
if not ldrbios
setmem1	lxi	d,8000h		; addiere 8000h zu dmaadresse
	dad	d		;
	shld	dmaadr		;
				; lege untere 3 kacheln nach 8000h
	mvi	b,80h		;
	mvi	c,p$ram$table	;
	lda	@dbnk		; schalte gewuenschte bank nach 8000h
	adi	2		;
	outp	a		;
	mvi	b,90h		;
	outp	a		;
	mvi	b,0a0h		;
	outp	a		;
	ret			;
endif

bank0
if not ldrbios
	lda	@cbnk		; setze alte bank
	call	?bank		;
endif
	ret

roderw	ds	1

if not ldrbios
	dseg			; rest is banked
endif


;--------------
TEST$FORMAT:
	;* TESTET DAS FORMAT DER DISK, DIE SICH IM VON
	;* @rdrv SPEZIFIZIERTEN LAUFWERK BEFINDET UND VERGLEICHT
	;* ES MIT DEN IN DISK$TYPE$LIST ERLAUBTEN FORMATEN.
	;* IST DAS FORMAT NICHT ERKENNBAR, ODER IN DISK$TYPE$LIST
	;* NICHT VEREINBART, SO KEHRT TEST$FORMAT MIT AKKU=0FFH
	;* ZURUECK. KONNTE DAS FORMAT ERMITTELT WERDEN UND WAR ES AUCH IN
	;* DISK$TYPE$LIST VEREINBART, DANN KEHRT TEST$FORMAT MIT AKKU=disktyp
	;* ZURUECK. 
	;* DER DISK-TYP ENTSPRICHT DER LAUFENDEN NUMMER DES EINTRAGS
	;* IN DER DISK$TYPE$LIST TABELLE.
	;
	lda	@rdrv		;SETZE DAS ZU TESTENDE LAUFWERK
	ani	03h		;maskiere die oberen 6 bits
	STA	UNIT		;
	mvi	c,2		;* versuche mit 2 Stepraten
	MVI	B,2		;* zwei * 2 TEST-VERSUCHE
	MVI	A,1		;AUF SPUR 1
	STA	TEST$TRACK	;
TESTF1:	PUSH	B		;
	call	fastset		;360 upm
	CALL	monon		;BENUTZE TEST-PROGRAMM
	CALL	mtest		;AUS MONITOR
	CALL	monoff		;
	POP	B		;
	ORA	A		;WAR TEST ERFOLGREICH ?
	JRZ	TESTF3$fast	;SPRUNG WENN JA
	PUSH	B		;
	call	slowset		;300 upm
	CALL	monon		;BENUTZE TEST-PROGRAMM
	CALL	mtest		;AUS MONITOR
	CALL	monoff		;
	POP	B		;
	ORA	A		;WAR TEST ERFOLGREICH ?
	JRZ	TESTF3$slow	;SPRUNG WENN JA
	DJNZ	TESTF1		;SONST MAXIMAL DREI VERSUCHE
tstep2:	dcr	c		;* schon mit anderer steprate
	jrz	testf2		;* versucht? zero=ja
	lda	@rdrv		;* Laufwerk 0...3
	ani	3		;* maskieren
	inr	a		;* wird 1 .. 4
	mov	b,a		;* und als Zaehler verwenden
	lda	seeknr		;* double step vector holen
	mov	l,a		;*
	xra	a		;* <A> = 0
	stc			;* carry setzen und an die dem Laufwerk
tstepl:	ral			;* entsprechende Position schieben
	djnz	tstepl		;*
	xra	l		;* zugehoeriges bit invertieren
	sta	seeknr		;* und vector ablegen
	mvi	b,2		;* noch mal 2 Versuche
	jr	testf1		;* und von vorn	


TESTF2:	MVI	A,0FFH		;SONST RUECKSPRUNG MIT AKKU=0FFH
	RET			;


TESTF3$slow:
	lda	test$type
	ori	slow
	sta	test$type
TESTF3$fast:

TESTF3:				;OK, FORMAT DATEN STEHEN IN TEST$TYPE
				;* UND test$msek
	lxi	h,rest+3	;* gelesene track nr
	lda	test$track	;* mit geforderter track nr
	cmp	m		;* vergleichen
	jrnz	tstep2	;* Fehler
	lda	@rdrv		;* Laufwerksnr wieder
	ani	3		;* als Schleifenzaehler
	inr	a		;* verwenden
	mov	b,a		;*
	lda	seeknr		;* double step vector
tstepl1:			;*
	rrc			;* zugehoeriges Bit nach
	djnz	tstepl1		;* bit 7 Sektoranzahl 	
	ani	80h		;*
	lxi	h,test$msek	;*
	ora	m		;*
	mov	e,a		;* Sektoranzahl und double step bit

	MVI	B,0		;ZAEHLER FUER DISKTYP
	LDA	TEST$TYPE	;TYPE IN D
	MOV	D,A		;
	LXI	H,DISK$TYPE$LIST;ZEIGER AUF VEREINBARTE FORMATE
TESTF4:	MOV	A,M
	ANI	08H		;ENDE DER LISTE
	JRNZ	TESTF2		;DANN MIT FEHLER-MELDUNG ZURUECK
	MOV	A,M		;VERGLEICHE EINTRAG MIT DE
	CMP	D		;IST TYP GLEICH?
	JNZ	TESTF5		;NEIN testen auf speed
TESTF6:	INX	H		;TYP WAR GLEICH
	MOV	A,M		;STIMMT AUCH NOCH DIE SEKTORGROESSE
	CMP	E		;
	JNZ	INX7		;NEIN EINEN EINTRAG WEITER
				;
				;OK, DISK WURDE ERKANNT
	call	show$disk$type	;AD: Show the detected format, HL=Sector of format
	mov	a,b		;
	RET			;
				;
TESTF5:	xra	d		;einzige diff ist speed ?
	ani	11101111b
	jrz	testf6		; ja : nehme gleichen typ an

INX8	INX	H		;EINEN DISK-TYP WEITER
INX7	INX	H		;
	INX	H		;
	INX	H		;
	INX	H		;
	INX	H		;
	INX	H		;
	INX	H		;
	INR	B		;
	JR	TESTF4		;


;********************************************************************
;
;HIER WERDEN DIE MOEGLICHEN DISK-FORMATE VEREINBART
;
;
;

	;
	;DIESE LISTE DEFINIERT DIE VOM BETRIEBSSYSTEM LESBAREN
	;PLATTEN-TYPEN
	;DIE LISTE BESTEHT AUS BELIEBIG VIELEN EINTRAEGEN VON
	;JE 8 BYTE, DIE WIE NACHFOLGEND BESCHRIEBEN AUFGEBAUT
	;SIND:
	;	BYTE 1	:DISK-TYP WIE VON MONTEST ERMITTELT
	;	BYTE 2	:SEKTOR-ANZAHL
	;	BYTE 3	:GAP-LAENGE DIE DER UPD 765 VERWENDEN SOLL
	;	BYTE 4	:WRITE PRECOMPENSATION
	;	BYTE 5-6:ADRESSE DES DPB FUER DIESES FORMAT
	;	BYTE 7-8:ADRESSE DER SEKTOR SKEW-TABLE
	;
	; 8 byte laenge darf nicht geaendert werden
	;
	;TEST$FORMAT VERGLEICHT DIE BEIDEN ERSTEN BYTES MIT
	;TEST$TYPE UND TEST$MSEK DIE DAS UNTERPROGRAM MONTEST
	;LIEFERTT.
	;
	SSIDE	EQU	000H	;EQUATES FUER TYPE
	DSIDE	EQU	080H	;
	SDENS	EQU	000H	;
	DDENS	EQU	040H	;
	MAXIF	EQU	000H	;
	MINIF	EQU	020H	;
	S0128	EQU	000H	;
	S0256	EQU	001H	;
	S0512	EQU	002H	;
	S1024	EQU	003H	;
	FAST	EQU	000H	; 360 UPM
	SLOW	EQU	010H	; 300 UPM
	;
	NODBLST	EQU	00h
if track80
	DBLST   EQU	80h	;* fuer 40 track formate auf 80 track disks
else
	DBLST   EQU	00h
endif


DPTXT:		DB	' erkannt',13,10,0
DPTXT2:		DB	': Format ',0

show$disk$type:			;AD: b is the format number
	push	a
	push	h
	push	b
	push	d
	mov	a,b		; now a=format
	push	a
	lda	@rdrv
	adi	'A'
	mov	c,a
	call	?cono
	pop	a

	push	a
	lxi	h,DPTXT2	; : Format
	call	?pmsg
	pop	a
	push	a
	mov	l,a
	mvi	h,0
	call	?pdec
	mvi	c,','
	call	?cono
	mvi	c,' '
	call	?cono
	pop	a

	add	a		; * 2 = offset in pointer table
	lxi	h,DISK$TXT	; hl=pointer table
	mov	c,a
	mvi	b,0
	dad	b		; add hl,bc, BC points to table entry
	MOV	E,M		; LD E,(HL)
	INX	H
	MOV	D,M		; LD D,(HL)
	XCHG			; EX DE,HL 
	call	?pmsg		; show new format text

	lxi	h,DPTXT
	call	?pmsg
	pop	d
	pop	b
	pop	h
	pop	a
	ret


DP8S0TX:	DB	'77 MAXI SS SD 26/128',0
DP8D3TX:	DB	'77 MAXI DS DD 8/1024',0
DP8D1ATX:	DB	'77 MAXI DS DD 26/256',0
DP8D2ATX:	DB	'77 MAXI SS DD 26/256',0
DP8D3ATX:	DB	'77 MAXI DS DD 8/1024',0
DP8D4TX:	DB	'80 MAXI DS DD 18/512 - 1,44MB Skew3',0
DP5D1TX:	DB	'40 SS DD 16/256',0
DP5D2TX:	DB	'40 SS DD 5/1024',0
DP5D2ATX:	DB	'40 SS DD 10/512 Skew2',0
DP5D3ATX:	DB	'80 DS DD 10/512 Skew2 Prof',0
DP5D4TX:	DB	'Vortex DS DD',0
DP5D4ATX:	DB	'MSDOS',0
DP5D5TX:	DB	'MZ-8.xx',0
DPMAIS10TX:	DB	'MAI S/10',0


DISK$TXT:
	DW	DP8S0TX		; Format Description Text Table
	DW	DP8D3TX		; 1
	DW	DP8D1ATX	; 2
	DW	DP8D2ATX	; 3.
	DW	DP8D3ATX	; 4
	DW	DP8D4TX		; 5 1,44 MB CPM/86
	DW	DP5D1TX		; 6 .
	DW	DP5D2TX		; 7 .
	DW	DP5D2ATX	; 8 .
	DW	DP5D3ATX	; 9
	DW	DP5D4TX		; 10 Vortex
	DW	DP5D4ATX	; 11 MSDos
	DW	DP5D5TX		; 12 MZ-8.xx
	DW	DPMAIS10TX	; 13 MAI S/10


DISK$TYPE$LIST:
	DB	SSIDE OR SDENS OR MAXIF OR S0128	; 0
	DB	26
	DB	07,0		; GAP, write precomp
	DW	DP8S0,SKEW26
	;
	DB	SSIDE OR DDENS OR MAXIF OR S1024	; 1
	DB	8
	DB	35H,2
	DW	DP8D3,SKEW8
	;
	DB	DSIDE OR DDENS OR MAXIF OR S0256	; 2
	DB	26
	DB	7,2
	DW	DP8D1A,SKEW26
	;
	DB	SSIDE OR DDENS OR MAXIF OR S0256	; 3
	DB	26
	DB	7,2
	DW	DP8D2A,SKEW15

;	DB	DSIDE OR DDENS OR MAXIF OR S0512
;	DB	15
;	DB	18H,2
;	DW	DP8D2A,SKEW15                       
	;
	DB	DSIDE OR DDENS OR MAXIF OR S1024	; 4
	DB	8
	DB	35H,2
	DW	DP8D3A,SKEW8
;
; AD: PC 3,5" 80 Track, 18 Sektoren
;     CP/M 86 on 1.44MB floppies
;
	DB	DSIDE OR DDENS OR MAXIF OR S0512	; 5
	DB	18
	DB	1BH,2			; GAP-Len, Write Precomp (??)
	DW	DP8D4,NOSKEW18		; DPB, Skew-Tabelle
	;
	DB	SSIDE OR DDENS OR MINIF OR S0256	; 6
	DB	16 OR DBLST
	DB	1BH,2
	DW	DP5D1,NOSKEW
	;
	DB	SSIDE OR DDENS OR MINIF OR S1024	; 7
	DB	5 OR DBLST
	DB	1BH,2
	DW	DP5D2,SKEW5
	;
;	DB	DSIDE OR DDENS OR MINIF OR S1024	;PROF80 #2 skew 1
;	DB	5
;	DB	1BH,2
;	DW	DP5D3,SKEW5

;	DB	DSIDE OR DDENS OR MINIF OR S1024	;Format R.Klaus
;	DB	5
;	DB	1BH,2
;	DW	DP5D3,SKEW52
	;
	DB	SSIDE OR DDENS OR MINIF OR S0512	; 8
	DB	10 OR DBLST
	DB	0EH,2
	DW	DP5D2A,SKEW10
	;
	DB	DSIDE OR DDENS OR MINIF OR S0512	; 9 PROF#4
	DB	10
	DB	0EH,2
	DW	DP5D3A,SKEW10
	;
	DB	DSIDE OR DDENS OR MINIF OR S0512          ; 10 VORTEX DS DD FORMAT
	DB	9
	DB	0EH,2
	DW	DP5D4,SKEW9
	;
	DB 	DSIDE OR DDENS OR MINIF OR S0512          ; 11 MS-PCDOS FORMAT
	DB	9 OR DBLST
	DB	0EH,2
	DW	DP5D4A,SKEW9
	;
	DB	DSIDE OR DDENS OR MINIF OR S0512	  ; 12 MZ-8.XX
	DB	8 OR DBLST
	DB	0EH,2
	DW	DP5D5,SKEW2
;
;	DB	SSIDE OR DDENS OR MINIF OR S0512	  ; IBM CP/M 86 SS DD
;	DB	10
;	DB	0EH,2
;	DW	DP5D5,SKEW2
	;
;	DB	DSIDE OR DDENS OR MINIF OR S0256	  ;MEZ-80 TA-PC
;	DB	16 OR DBLST
;	DB	1BH,2
;	DW	DP5D5A,SKEW3
	;
;	DB	DSIDE OR DDENS OR MINIF OR S0256	  ;TA-40 TRACK
;	DB	16
;	DB	1BH,2
;	DW	DP5D6,SKEW3	
;
DB	DSIDE OR DDENS OR MINIF OR S0256	  	;MAI S10
	DB	16
	DB	1BH,2
	DW	DPMAIS10,SKEWMAIS10
;
	DB	010H		;ENDE-KENNUNG



current$dph	ds	2

if ldrbios
*****************************************************************
*								*
*  Checksum Vectors						*
*  Each vector requires 1 bit for every four directory entries	*
*								*
*****************************************************************                
csv 	ds	128			; checksum vector

*****************************************************************
*								*
*  Allocation Vectors						*
*  Each vector requires 2 bits for each block on the drive	*
*								*
*****************************************************************
alv 	ds	256

*****************************************************************
*								*
*  Directory Buffer  						*
*								*
*****************************************************************
dirbuf	ds	512

*****************************************************************
*								*
*  Data Buffer       						*
*								*
*****************************************************************
dtabuf	ds	512

endif
	end
